package jp.mosp.common;

import java.sql.Connection;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import jp.mosp.common.common.BaseAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;

import jp.mosp.common.dao.CtAccountDao;
import jp.mosp.common.dao.MosPUserDao;
import jp.mosp.common.dto.CmAspUserDto;
import jp.mosp.common.dto.CmUserDto;
import jp.mosp.common.dto.CtAccountDto;
import jp.mosp.common.dto.MosPUserDto;

import jp.mosp.human.dao.MKihonDao;
import jp.mosp.human.dto.MKihonDto;

/**
 * 認証処理ユーティリティ
 * @since 3.0.2
 * @version 0.0.1
 * @author m.yoshida
 */
public class UserAuthUtility {

	private Map<String, Object> authMap = new HashMap<String, Object>();

	private Properties cfg;
	private String cmd;
	private CmAspUserDto aspUser;
	private Connection conn;

	private CmUserDto user = new CmUserDto();
	private MosPUserDto mospUser = null;
	private CtAccountDto dto;

	public static final String KEY_MESSAGE_CODE 	= "msgCode";
	public static final String KEY_EXCEPTION_CODE 	= "exCode";
	public static final String KEY_USER 			= "user";

	/**
	 * コンストラクタ
	 */
	public UserAuthUtility() {

	}

	/**
	 * コンストラクタ
	 * @param cfg			MosPアプリケーション設定(/WEB-INF/mosp.properties)。 
	 * @param cmd			リクエストされたCommand。
	 * @param aspUser		ログインASPユーザー。
	 * @param conn			DBコネクション。<br>
	 * getConnection(String, String, String, String) により、設定される。
	 */
	public UserAuthUtility(
			Properties cfg,
			String cmd,
			CmAspUserDto aspUser,
			Connection conn
	) {
		init(cfg, cmd, aspUser, conn);
	}

	/**
	 * コンストラクタ（認証処理実行）
	 * <p>
	 * 結果の取得方法等は、{@link UserAuthUtility#login(String, String)}を参照すること。
	 * </p>
	 * @param userId		対象ユーザID
	 * @param password		対象入力パスワード
	 * @param cfg			MosPアプリケーション設定(/WEB-INF/mosp.properties)。 
	 * @param cmd			リクエストされたCommand。
	 * @param aspUser		ログインASPユーザー。
	 * @param conn			DBコネクション。<br>
	 * getConnection(String, String, String, String) により、設定される。
	 * @throws Exception
	 */
	public UserAuthUtility(
			String userId,
			String password,
			Properties cfg,
			String cmd,
			CmAspUserDto aspUser,
			Connection conn
	) throws Exception {
		init(cfg, cmd, aspUser, conn);
		login(userId, password);
	}

	/**
	 * ユーティリティの初期化
	 * @param cfg			MosPアプリケーション設定(/WEB-INF/mosp.properties)。 
	 * @param cmd			リクエストされたCommand。
	 * @param aspUser		ログインASPユーザー。
	 * @param conn			DBコネクション。<br>
	 * getConnection(String, String, String, String) により、設定される。
	 */
	public void init(
			Properties cfg,
			String cmd,
			CmAspUserDto aspUser,
			Connection conn
	) {
		this.cfg = cfg;
		this.cmd = cmd;
		this.aspUser = aspUser;
		this.conn = conn;
	}

	/**
	 * 認証処理
	 * @param userId			対象ユーザID
	 * @param password			対象入力パスワード
	 * @throws Exception
	 * <p>
	 * ユーザを取得するには{@link UserAuthUtility#getCmUserDto()}で取得する。<br>
	 * 認証結果を取得するには{@link UserAuthUtility#isErrMessage()}を取得し、成否を判断する。<br>
	 * 認証を失敗したら、必ずメッセージコード{@link UserAuthUtility#getErrMessageCode()}と
	 * 例外コード{@link UserAuthUtility#getMosPExceptionCode()}を取得する。<br>
	 * メッセージコードからエラーメッセージを生成し、VOのエラーメッセージフィールドにセットする。
	 * 例外コードを{@link MospException#MospException(int)}にセットし、throwする。
	 * </p>
	 */
	public void login(String userId, String password) throws Exception {
		// ユーザーの取得
		user = new CmUserDto();
		user.setUserId(userId);
		MosPUserDao userDao = new MosPUserDao();
		userDao.initDao(cfg, cmd, aspUser, user, conn);
		mospUser = userDao.findForRegistered(userId);
		// アカウント情報の取得準備
		if (mospUser != null) {
			// ユーザーが取得できた場合
			// 削除チェック
			if (mospUser.getDeleteFlag() == 1) {
				setAuthFailedMessage(MospConst.MSG_AUTH_FAILED, MospConst.EX_AUTH_DELETED);
			}
			// アカウント情報の取得
			CtAccountDao dao = new CtAccountDao();
			dao.initDao(cfg, cmd, aspUser, user, conn);
			dto = dao.findCtAccountForUserId(mospUser.getUserId());
			if (dto == null) {
				// アカウント情報が取得できなかった場合
				// アカウント情報を作成
				dto = new CtAccountDto();
				dto.setUserId(mospUser.getUserId());
				dto.setAttempt(1);
				dao.insert(dto);
			} else {
				// アカウント情報が取得できた場合
				// ログイン試行回数確認
				int maxAttempt = Integer.parseInt(cfg.getProperty(MospConst.PPT_ACC_ATTEMPT));
				if (dto.getAttempt() >= maxAttempt) {
					// ログイン試行回数が設定値より大きい場合
					// 再試行インターバルを確認
					Date date = new Date(
							dto.getUpdateDate().getTime()
							+ Long.parseLong(cfg.getProperty(MospConst.PPT_ACC_INTERVAL)) * 1000
					);
					if (date.compareTo(new Date()) > 0) {
						// 再試行インターバルを経ずにログイン試行した場合
						// 試行回数のインクリメント
						dto.incrementAttempt();
						dao.update(dto);
						// アカウントロック例外を発行
						setAuthFailedMessage(MospConst.MSG_ACCOUNT_LOCK, MospConst.EX_ACCOUNT_LOCK);
					}
				}
			}
			// パスワードチェック
			checkPassWord(password);
		} else {
			// ユーザーが取得できなかった場合
			setAuthFailedMessage(MospConst.MSG_AUTH_FAILED, MospConst.EX_AUTH_NOT_EXIST);
		}
		// CmUserDtoをセットする。
		authMap.put(KEY_USER, user);
	}

	/**
	 * パスワードチェック
	 * @param mospUser		対象MosPUserDto
	 * @param accountDto	対象CtAccountDto
	 * @param user			対象CmUserDto
	 * @param password		対象入力パスワード
	 * @return
	 * <p>
	 * パスワードが正しい場合true、そうでない場合false
	 * </p>
	 * @throws Exception
	 */
	private void checkPassWord(
			String password
	) throws Exception {
		// DAOの準備
		CtAccountDao ctAccountDao = new CtAccountDao();
		ctAccountDao.initDao(cfg, cmd, aspUser, user, conn);
		// パスワード認証失敗フラグ
		boolean passwordFailed = true;
		// パスワードによる認証
		if (mospUser.getPassword().equals(MospUtility.getDigest(password))) {
			// 認証成功
			// アカウント情報の更新
			dto.setAttempt(0);
			ctAccountDao.update(dto);
			// ユーザー情報の設定
			mospUser.setPassword("");
			user.setUserId(mospUser.getUserId());
			user.setPassword(mospUser.getPassword());
			user.setUserName(mospUser.getUserName());
			user.setCommonCss("");
			user.setMospAuthority(mospUser.getAuthority());
			user.setPayrollAuthority("");
			user.setZaimuAuthority("");
			user.setSalesAuthority("");
			user.setExpenseAuthority("");
			user.setExt1Authority("");
			user.setExt2Authority("");
			user.setExt3Authority("");
			user.setExt4Authority("");
			user.setExt5Authority("");
			user.setDeleteFlag(mospUser.getDeleteFlag());
			// 入社日以降しかログインできないようにする。
			MKihonDao dao = new MKihonDao();
			dao.initDao(cfg, cmd, aspUser, user, conn);
			MKihonDto mKihonDto = dao.findForKey(mospUser.getKCode());
			Date entranceDate = null;
			CommonUtility util = new CommonUtility();
			if (mKihonDto != null) {
				entranceDate = util.convIntegerDateToDate(mKihonDto.getNyDate());
			}
			// 管理者権限の場合、人事基本情報は無い
			if (mospUser.getAuthority().equals(CommonConst.AUTHORITY_ADMIN)) {
				entranceDate = new Date(0);
			}
			if (entranceDate != null
					/*						
					 *  	2009/06/24	m.yoshida	入社日当日ログイン対応
					 */
					//&& util.getSystemDate().compareTo(entranceDate) > 0
					&& util.getSystemDate().compareTo(entranceDate) >= 0
			) {
				// 認証成功
				passwordFailed = false;
			}
		} else {
			// 認証失敗
			// アカウント情報の更新
			dto.incrementAttempt();
			ctAccountDao.update(dto);
		}
		// エラーメッセージ設定
		if (passwordFailed) {
			setAuthFailedMessage(MospConst.MSG_AUTH_FAILED, MospConst.EX_AUTH_FAILED);
		}
	}

	/**
	 * 認証失敗メッセージ設定
	 * @param msgCode			表示メッセージコード
	 * @param exCode			対象例外コード
	 * @throws MospException
	 */
	public void setAuthFailedMessage(String msgCode , int exCode) {
		authMap.put(KEY_MESSAGE_CODE, msgCode);
		authMap.put(KEY_EXCEPTION_CODE, exCode);
	}

	/**
	 * 認証失敗メッセージ有無
	 * @return
	 * <p>
	 * 認証失敗メッセージがある場合true、そうでない場合false<br>
	 * もし認証を失敗したら、必ず{@link MospException#MospException(int)}を呼び出すこと。<br>
	 * throwする前に、認証失敗用に{@link BaseAction#commit()}を呼び出すこと。
	 * </p>
	 */
	public boolean isErrMessage() {
		return authMap.get(KEY_MESSAGE_CODE) != null ? true: false;
	}

	/**
	 * CmUserDto取得
	 * @return　CmUserDto
	 */
	public CmUserDto getCmUserDto() {
		Object obj = authMap.get(KEY_USER);
		return obj != null ? (CmUserDto)obj: null;
	}

	/**
	 * 認証失敗メッセージ取得
	 * @return	認証失敗メッセージ
	 */
	public String getErrMessageCode() {
		Object obj = authMap.get(KEY_MESSAGE_CODE);
		return obj != null ? obj.toString(): "";
	}

	/**
	 * MosPExceptionコード取得
	 * @return	MosPExceptionコード
	 */
	public int getMosPExceptionCode() {
		Object obj = authMap.get(KEY_EXCEPTION_CODE);
		return obj != null ? (Integer)obj: 0;
	}

}
